package Abenteuer.Daten.Objekte;

import java.util.Vector;
import java.util.Enumeration;

/**
 * Die Klasse Gegenstand beschreibt einen einzelnen Gegenstand nach folgenden Merkmalen:
 * <ul>
 * <li>Ein Gegenstand hat einen Namen, mit dem er auch vom Parser erkannt wird</li>
 * <li>Der Gegenstand hat einen eindeutigen internen Namen, mit dem er refereziert werden kann</li>
 * <li>Der Gegenstand hat ein Gewicht.</li>
 * </ul> 
 * Diese Klasse verwaltet auch automatisch eine Liste aller Gegenstnde im Spiel, soda sie auch existieren 
 * knnen ohne von einer Person getragen zu werden oder sich in einem Raum zu befinden.
 * 
 * @author Dipl.-Ing. Michael Sonntag
 * @version 1.0
*/
public abstract class Gegenstand
{
    /**
    Erzeugt einen neuen Gegenstand. Es ist zu berprfen, da der interne Name auch wirklich eindeutig ist
    @param name Der ffentliche Name des Gegenstandes, nach dem er auch bei Benutzereingaben identifiziert wird
    @param internerName Der interne Name des Gegenstandes, er mu eindeutig sein.
    @param gewicht Gewicht des Gegenstandes in kg
    */
    protected Gegenstand(String name,String internerName,double gewicht)
    {
    }
        
    /**
    Gibt eine kurze Beschreibung des Gegenstandes aus (z. b. fr die Inventarliste).
    */
    public abstract void kurzBeschreibung();
    
    /**
    Gibt eine ausfhrliche Beschreibung des Gegenstandes aus (z. b. beim Besichtigen des Gegenstands).
    */
    public abstract void beschreibung();
    
    /**
    Gibt den Namen zurck.
    @return Name des Gegenstands
    */
    public String getName()
    {
    }
    
    /**
    Gibt den eindeutigen internen Namen zurck.
    @return Interner Name des Gegenstands
    */
    public String getInternerName()
    {
    }
    
    /**
    Gibt das Gewicht zurck.
    @return Gewicht des Gegenstands in kg
    */
    public double getGewicht()
    {
    }
    
    /**
    Sucht den Gegenstand nach seinem eindeutigen internen Namen. Dazu wird die interne Liste durchsucht.
    @param internerName der eindeutige Name des Gegenstandes, der gesucht werden soll.
    @return Gegenstand mit diesem internen Namen oder null, falls nicht gefunden
    */
    public static Gegenstand findeGegenstand(String internerName)
    {
    }
        
}
